script.on_event(defines.events.on_player_created, function(event)
  local player = game.players[event.player_index]
  player.insert{name="iron-plate", count=8}
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="burner-mining-drill", count = 1}
  player.insert{name="stone-furnace", count = 1}
  player.force.chart(player.surface, {{player.position.x - 200, player.position.y - 200}, {player.position.x + 200, player.position.y + 200}})
  if (#game.players <= 1) then
    game.show_message_dialog{text = {"msg-intro"}}
  else
    player.print({"msg-intro"})
  end
end)

script.on_event(defines.events.on_player_respawned, function(event)
  local player = game.players[event.player_index]
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
end)

script.on_event(defines.events.on_rocket_launched, function(event)
  local force = event.rocket.force
  if event.rocket.get_item_count("satellite") == 0 then
    if (#game.players <= 1) then
      game.show_message_dialog{text = {"gui-rocket-silo.rocket-launched-without-satellite"}}
    else
      for index, player in pairs(force.players) do
        player.print({"gui-rocket-silo.rocket-launched-without-satellite"})
      end
    end
    return
  end
  if not global.satellite_sent then
    global.satellite_sent = {}
  end
  if global.satellite_sent[force.name] then
    global.satellite_sent[force.name] = global.satellite_sent[force.name] + 1   
  else
    game.set_game_state{game_finished=true, player_won=true, can_continue=true}
    global.satellite_sent[force.name] = 1
  end
  for index, player in pairs(force.players) do
    if player.gui.left.rocket_score then
      player.gui.left.rocket_score.rocket_count.caption = tostring(global.satellite_sent[force.name])
    else
      local frame = player.gui.left.add{name = "rocket_score", type = "frame", direction = "horizontal", caption={"score"}}
      frame.add{name="rocket_count_label", type = "label", caption={"", {"rockets-sent"}, ":"}}
      frame.add{name="rocket_count", type = "label", caption=tostring(global.satellite_sent[force.name])}
    end
  end
end)

script.on_event(defines.events.on_player_joined_game, function(event)
  local play = game.players[event.player_index]
  play.print({"", "Welcome"})
  foreachplayer()
end)

script.on_event(defines.events.on_player_left_game, function(event)
  foreachplayer()
end)

script.on_event(defines.events.on_gui_click, function(event)
  local player = game.players[event.player_index]
  if event.element.name == "btn_readme" then
    player.print({"", "Opened readme."})
    drawMOTD(player, "Rules")
  elseif event.element.name == "btn_readme_rules" then
    player.print({"", "Opened readme > Rules."})
    player.gui.center.README.destroy()
    drawMOTD(player, "Rules")
  elseif event.element.name == "btn_readme_tips_and_tricks" then
    player.print({"", "Opened readme > Tips and tricks."})
    player.gui.center.README.destroy()
    drawMOTD(player, "Tips & tricks")
  elseif event.element.name == "btn_readme_chat" then
    player.print({"", "Opened readme > Chat."})
    player.gui.center.README.destroy()
    drawMOTD(player, "Chat")
  elseif event.element.name == "btn_readme_admins" then
    player.print({"", "Opened readme > Admins."})
    player.gui.center.README.destroy()
    drawMOTD(player, "Admins")
  elseif event.element.name == "btn_readme_players" then
    player.print({"", "Opened readme > Players."})
    player.gui.center.README.destroy()
    drawMOTD(player, "Players")
  elseif event.element.name == "btn_readme_close" then
    player.print({"", "Closed readme."})
    player.gui.center.README.destroy()
  elseif event.element.name == "btn_refresh" then
    foreachplayer()
    player.print({"", "Player list has been refresed."})
  end
end)

function drawMOTD(play, page)
  local rules = {
    "Hacking/cheating, exploiting and abusing bugs is not allowed.",
    "Do not disrespect any player in the server (This includes staff).",
    "Do not spam, this includes stuff such as chat spam, item spam, chest spam etc.",
    "Do not laydown concrete with bots when you dont have permission to.",
    "Do not make train roundabouts.",
    "Do not ask for rank.",
    "Use common sense",
  }
  local chat = {
    "Chatting for new players can be difficult because it’s different than other games!",
    "It’s very simple, the button you need to press is the “GRAVE/TILDE key”",
    "it’s located under the “ESC key”. If you would like to change the key go to your",
    "controls tab in options. The key you need to change is “Toggle Lua console”",
    "it’s located in the second column 2nd from bottom."
  }
  local admins = {
    "This list contains all the people that are admin in this world. Do you want to become",
    "an admin dont ask for it! an admin will see what you've made and the time you put",
    "in the server."
  }
  local players = {
    "These are the players who have supported us in the making of this factory. Without",
    "you the player we wouldn't have been as far as we are now. These players have put",
    "more than one hour into this world."
  }
  if play.gui.center.README ~= nil then
    play.gui.center.README.destroy()
  end
  local frame = play.gui.center.add{name= "README", type = "frame", direction = "vertical"}
        frame.add{type = "scroll-pane", name= "flowContent", direction = "vertical", vertical_scroll_policy="always", horizontal_scroll_policy="never"}
        frame.add{type = "flow", name= "flowNavigation",direction = "horizontal"}
        frame.flowNavigation.add{name="btn_readme_rules", type = "button", caption="RULES", tooltip= "Rules."}
        frame.flowNavigation.add{name="btn_readme_tips_and_tricks", type = "button", caption="TIPS & TRICKS", tooltip= "Tips & Tricks."}
        frame.flowNavigation.add{name="btn_readme_chat", type = "button", caption="CHAT", tooltip= "How to chat."}
        frame.flowNavigation.add{name="btn_readme_admins", type = "button", caption="ADMINS", tooltip= "All the admins and info."}
        frame.flowNavigation.add{name="btn_readme_players", type = "button", caption="Players", tooltip= "All the players that have joined this map."}
        frame.flowNavigation.add{name="btn_readme_close", type = "button", caption="COSE", tooltip= "Close the readme."}
        frame.flowContent.style.maximal_height = 400
        frame.flowContent.style.minimal_height = 400
        frame.flowContent.style.maximal_width = 500
        frame.flowContent.style.minimal_width = 500
        frame.flowNavigation.style.maximal_width = 500
        frame.flowNavigation.style.minimal_width = 500
  if page == "Rules" then
    frame.caption = page
    for i, rule in pairs(rules) do
      frame.flowContent.add{name=i, type="label", caption={"", i ,". ", rule}}
    end
  elseif page == "Tips & tricks" then
    frame.flowContent.add{name="WIP", type="label", caption={"","WIP, come back later."}}
    frame.caption = page
  elseif page == "Chat" then
    frame.caption = page
    for i, line in pairs(chat) do
      frame.flowContent.add{name=i, type="label", caption={"", line}}
    end
  elseif page == "Admins" then
    for i, line in pairs(admins) do
      frame.flowContent.add{name=i, type="label", caption={"", line}}
    end
    frame.flowContent.add{name="AdminTable", type="table", colspan=4}
    frame.flowContent.AdminTable.style.minimal_width = 500
    frame.flowContent.AdminTable.style.maximal_width = 500
    frame.flowContent.AdminTable.add{name="id", type="label", caption="id"}
    frame.flowContent.AdminTable.add{name="name", type="label", caption="name"}
    frame.flowContent.AdminTable.add{name="status", type="label", caption="status"}
    frame.flowContent.AdminTable.add{name="hours", type="label", caption="Hours"}
    for i, player in pairs(game.players) do
      if player.admin == true then
        frame.flowContent.AdminTable.add{name=i, type="label", caption=i}
        frame.flowContent.AdminTable.add{name=player.name, type="label", caption=player.name}
        if player.connected == true then
          frame.flowContent.AdminTable.add{name=player.name .. "Status", type="label", caption="ONLINE"}
        else
          frame.flowContent.AdminTable.add{name=player.name .. "Status", type="label", caption="OFFLINE"}
        end
        frame.flowContent.AdminTable.add{name=player.name .. "Hours", type="label", caption=ticktohour(player.online_time)}
      end
    end
    frame.caption = page
    elseif page == "Players" then
    for i, line in pairs(players) do
      frame.flowContent.add{name=i, type="label", caption={"", line}}
    end
    frame.flowContent.add{name="PlayerTable", type="table", colspan=4}
    frame.flowContent.PlayerTable.style.minimal_width = 500
    frame.flowContent.PlayerTable.style.maximal_width = 500
    frame.flowContent.PlayerTable.add{name="id", type="label", caption="id"}
    frame.flowContent.PlayerTable.add{name="name", type="label", caption="name"}
    frame.flowContent.PlayerTable.add{name="status", type="label", caption="status"}
    frame.flowContent.PlayerTable.add{name="hours", type="label", caption="Hours"}
    for i, player in pairs(game.players) do
      if tonumber(ticktohour(player.online_time)) >= 1 then
        frame.flowContent.PlayerTable.add{name=i, type="label", caption=i}
        frame.flowContent.PlayerTable.add{name=player.name, type="label", caption=player.name}
        if player.connected == true then
          frame.flowContent.PlayerTable.add{name=player.name .. "Status", type="label", caption="ONLINE"}
        else
          frame.flowContent.PlayerTable.add{name=player.name .. "Status", type="label", caption="OFFLINE"}
        end
        frame.flowContent.PlayerTable.add{name=player.name .. "Hours", type="label", caption=ticktohour(player.online_time)}
      end
    end
    frame.caption = page
  end
end

function foreachplayer ()
  for i, player in pairs(game.players) do
    if player.connected == true then
        drawAdminPlayerList(player)
    end
  end
end

function drawAdminPlayerList (play)
  if play.gui.top.PlayerList ~= nil then
    play.gui.top.PlayerList.destroy()
  end
  local frame = play.gui.top.add{name= "PlayerList", type = "frame", direction = "vertical"}
        frame.add{type = "flow", name= "flow1",direction = "horizontal", vertical_scroll_policy= "auto"}
        frame.flow1.add{name="btn_readme", type = "button", caption="README", tooltip= "Rules, Tips & Tricks, How to chat."}
        frame.flow1.add{name="btn_refresh", type = "button", caption="REFRESH", tooltip= "Refresh your player list."}
        frame.add{type = "flow", name= "flow2",direction = "vertical", vertical_scroll_policy= "auto"}
  for i, player in pairs(game.players) do
    if player.connected == true then
      if player.admin == true then
        if player.name == "badgamernl" or player.name == "BADgamerNL" then
          frame.flow2.add{type = "label",  name=player.name, style="caption_label_style", caption={"", ticktohour(player.online_time), " H - " , player.name , " - OWNER"}}
          frame.flow2[player.name].style.font_color = {r=170,g=0,b=0}
        else
          frame.flow2.add{type = "label",  name=player.name, style="caption_label_style", caption={"", ticktohour(player.online_time), " H - " , player.name , " - ADMIN"}}
          frame.flow2[player.name].style.font_color = {r=233,g=63,b=233}
        end
      else
        frame.flow2.add{type = "label",  name=player.name, style="caption_label_style", caption={"", ticktohour(player.online_time), " H - " , player.name}}
        frame.flow2[player.name].style.font_color = {r=255,g=159,b=27}
      end
    end
  end
end

function ticktohour (tick)
  	local hour = tostring(math.floor((tick * 0.01667) / 3600))
    return hour
end